//
//  ViewController.swift
//  VideoApp
//
//  Created by Vasil Nunev on 11/07/2017.
//  Copyright © 2017 nunev. All rights reserved.
//

import AVKit
import UIKit
import AVFoundation
import Foundation

class ViewController_AVPlayer_List: UIViewController {
     
    var playVideoIndex:Int = 0
    var jsonCanales:String = ""
    var urlEPG:String = ""
    
    private var player: AVQueuePlayer?
    private var queuePlayer: AVPlayerLayer?
    private var isPlayed = true
    private var frameQueuePlayer:CGRect?
    private var frameView:CGRect?
    private  var btnNext = UIButton()
    private  var btnInfoEPG = UIButton()
    private  var btnPreview = UIButton()
    private  var btnClose = UIButton()
    // private  var  routePickerView = AVRoutePickerView()
    private  var activityView :  UIActivityIndicatorView?
    private var isLandscapeLeft : UIInterfaceOrientation = .landscapeLeft
    private var viewTopEPG : UIView = UIView()
    private var viewBottomEPG : UIView = UIView()
    private var  txtNumeroCanal  : UITextField  = UITextField()
    private var  imagen_canal  : UIImageView  = UIImageView()
    private var  programa_actual_nombre : UILabel  = UILabel()
    private var  programa_horario_inicio  : UILabel  = UILabel()
    private var  programa_horario_fin  : UILabel  = UILabel()
    private var  programa_proximo_nombre  : UILabel  = UILabel()
    private var  programa_actual  : UILabel  = UILabel()
    private var  progressBar  : UIProgressView  = UIProgressView()
    private var  titulo_canal  : UILabel  = UILabel()
    private var  descripcion_canal  : UILabel  = UILabel()
    private var  currentCanal:VideoModel?
    
    
    private var list:Array<Epg> = []
    private var listCanales:Array<VideoModel> = []
    
    
    
    
    //MARK: eventos del ciclo de vida del controlador
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
    }
    override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator) {
        super.viewWillTransition(to: size, with: coordinator)
        if UIDevice.current.orientation.isLandscape {
            
            
            print("Landscape")
            self.queuePlayer?.videoGravity = AVLayerVideoGravity.resizeAspectFill
            
            //  self.queuePlayer?.frame = CGRect(x: 0, y: 0, width: 700, height:375)
            
            self.queuePlayer?.frame = self.frameQueuePlayer!
        } else {
            print("Portrait")
            // self.queuePlayer?.frame = CGRect(x: 0, y: 0, width: 380, height:200)
            self.queuePlayer?.frame = self.frameQueuePlayer!
            self.view.frame  = self.frameView!
            //self.view.frame = CGRect(x:0, y: 200, width: (self.view.frame.size.height), height: (self.view.frame.size.width))
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        self.navigationController?.setNavigationBarHidden(true, animated: true)
        self.navigationController?.setToolbarHidden(true, animated: true)
        let value = UIInterfaceOrientation.landscapeLeft.rawValue
        UIDevice.current.setValue(value, forKey: "orientation")
        
        self.modalPresentationStyle = .fullScreen
        
    }
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        player?.pause() // 1. pause the player to stop it
        queuePlayer?.player = nil // 2. set the playerLayer's player to nil
        queuePlayer?.removeFromSuperlayer() // 3 remove the playerLayer from it's superLayer
        
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        buildJSONToEPG()
        startDemoVideo(canales: self.listCanales, playVideoIndex : self.playVideoIndex)
        buildButtons()
    }
    
   func buildJSONToEPG()
   {
        
        do{
            if let json =    jsonCanales.data(using: String.Encoding.utf8){
                if let canales = try JSONSerialization.jsonObject(with: json, options: .allowFragments) as? [[String:Any]] {
                    
                    for canal in canales{
                        
                        let studio = canal["studio"] as! Int
                        let titulo = canal["titulo"] as! String
                        let imagenPath = canal["imagenPath"] as! String
                        let descripcion = canal["descripcion"] as! String
                        let numeroCanal = canal["numeroCanal"] as! Int
                        let linkReproductor = canal["linkReproductor"] as! String
                        
                        let video:VideoModel =  VideoModel(studio: studio, titulo: titulo, imagenPath: imagenPath, descripcion: descripcion, numeroCanal: numeroCanal, linkReproductor: linkReproductor)
                        self.listCanales.append(video)
                    }
                }
            }
        }catch {
            print(error.localizedDescription)
        }
    }
    //MARK: inicializar reproductor con los canales para hacer zapping
    private func startDemoVideo(canales: Array<VideoModel> , playVideoIndex : Int) {
        player = AVQueuePlayer()
        queuePlayer = AVPlayerLayer(player: player)
        
        
        guard let queuePlayer = queuePlayer else { fatalError("Error creating player layer") }
        
        queuePlayer.frame = self.view.bounds
        self.frameQueuePlayer =  queuePlayer.frame
        
        queuePlayer.backgroundColor = UIColor.black.cgColor
        
        //        self.view.frame = CGRect(x: 0, y: 0, width: (self.view.frame.size.height), height: (self.view.frame.size.width))
        
        
        self.frameView =    self.view.frame
        
        self.view.layer.addSublayer(queuePlayer)
        
        
        delayWithSeconds(10) {
            
            if(self.viewBottomEPG.isHidden == false){
                self.btnPreview.isHidden = false
                self.btnNext.isHidden = false
            }else{
                self.btnClose.isHidden = true
                self.btnNext.isHidden = true
                self.btnPreview.isHidden = true
                self.btnInfoEPG.isHidden = true
            }
            // self.routePickerView.isHidden = true
        }
        
       currentCanal = canales[playVideoIndex]
        let url = URL(string: currentCanal!.linkReproductor)
        let newItem = AVPlayerItem(url: url!)
        self.player?.replaceCurrentItem(with: newItem)
        
        DispatchQueue.main.async {
            self.addObserverPlayerItem()
            
            self.player?.play()
        }
        
    }
    
    
    
    
    //MARK: Agregar observadores al reproductor
    private func addObserverPlayerItem(){
        if let playerItem = self.player?.currentItem{
            playerItem.addObserver(self, forKeyPath: "playbackBufferEmpty", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "playbackLikelyToKeepUp", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "playbackBufferFull", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "duration", options: [.new, .initial], context: nil)
            self.player?.addObserver(self, forKeyPath: #keyPath(AVPlayer.currentItem.status), options: [.new, .initial], context: nil)
            self.player?.addObserver(self, forKeyPath: #keyPath(AVPlayer.status), options: [.new, .initial], context: nil)
            
        }
    }
    //MARK: resultados de los observadores en el reproductor
    override public func observeValue(forKeyPath keyPath: String?, of object: Any?, change: [NSKeyValueChangeKey : Any]?, context: UnsafeMutableRawPointer?) {
        
        guard let currentItem = self.player!.currentItem else {return}
        
        if object is AVPlayerItem {
            switch keyPath {
               case "duration":
                  let interval = CMTime(seconds: 10, preferredTimescale: CMTimeScale(NSEC_PER_SEC))
                   let mainQueue = DispatchQueue.main
                     _ = self.player!.addPeriodicTimeObserver(forInterval: interval, queue: mainQueue, using: { [weak self] time in
                        
                        print("time "+(self?.getTimeString(from: currentItem.currentTime()))!)
                        
                  })
                
                case "playbackBufferEmpty":
                    // Show loader
                    self.showActivityIndicatory()
                
                case "playbackLikelyToKeepUp":
                    // Hide loader
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                
                case "playbackBufferFull":
                    // Hide loader
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                case #keyPath(AVPlayer.currentItem.status):
                    
                    let newStatus: AVPlayerItem.Status
                    if let newStatusAsNumber = change?[NSKeyValueChangeKey.newKey] as? NSNumber {
                        newStatus = AVPlayerItem.Status(rawValue: newStatusAsNumber.intValue)!
                    } else {
                        newStatus = .unknown
                    }
                    if newStatus == .failed {
                        NSLog("SA Detected Error: \(String(describing: self.player?.currentItem?.error?.localizedDescription)), error: \(String(describing: self.player?.currentItem?.error))")
                }
                case #keyPath(AVPlayer.status):
                    print()
                case .none:
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                case .some(_):
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
            }
        }
    }
    
    // MARK: construir y dibujar botones en el reproductor
    private func buildButtons() {
        
        let canal:VideoModel = listCanales[self.playVideoIndex]
        print(canal)
        
        viewTopEPG = UIView(frame: CGRect(x: 0,  y: 0, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        let colorTop =  UIColor(red: 0.00, green: 0.00, blue: 0.00, alpha: 1.00).cgColor
        let colorBottom = UIColor(red: 0.55, green: 0.52, blue: 0.52, alpha:  0.2).cgColor
        
        let gradientLayer: CAGradientLayer = CAGradientLayer()
        gradientLayer.colors = [colorTop, colorBottom]
        gradientLayer.locations = [0.0, 1.0]
        gradientLayer.frame = viewTopEPG.frame
        
        
        
        let caja_cuadrada_componente_numero_canal = UIView(frame: CGRect(x: 0,  y: 0, width: 80.00, height: viewTopEPG.frame.height))
        caja_cuadrada_componente_numero_canal.backgroundColor = UIColor(red: 0.0, green: 0.0, blue:0.0, alpha:  0.8)
        
        self.txtNumeroCanal =   UITextField(frame: CGRect(x: 0, y: 0, width: 80.00, height: viewTopEPG.frame.height));
        self.txtNumeroCanal.text = String(canal.numeroCanal)
        
        self.txtNumeroCanal.textColor = .white
        self.txtNumeroCanal.font = UIFont.boldSystemFont(ofSize: 35.0)
        self.txtNumeroCanal.textAlignment = .center
        caja_cuadrada_componente_numero_canal.addSubview(txtNumeroCanal )
        
        
        
        let caja_cuadrada_componente_imagen_canal = UIView(frame: CGRect(x: 80,  y: 0, width: 80.00, height: viewTopEPG.frame.height))
        
        self.imagen_canal = UIImageView(frame: CGRect(x: 0, y: 0, width: 80.00, height: viewTopEPG.frame.height))
        let url_imagen_canal = URL(string: canal.imagenPath)
        if let data = try? Data(contentsOf: url_imagen_canal!)
        {
            let image: UIImage = UIImage(data: data)!
            self.imagen_canal.image = image;
        }else{
            print("error SSL imagen ")
        }
        caja_cuadrada_componente_imagen_canal.addSubview(self.imagen_canal)
        
        
        
        let programacion_titulos_actual = UIView(frame: CGRect(x:  caja_cuadrada_componente_imagen_canal.frame.maxX + 10,  y: 40, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        self.programa_actual.text  = "AHORA: "
        self.programa_actual.textColor = .white
        self.programa_actual.textAlignment = .center
        self.programa_actual.font = UIFont.boldSystemFont(ofSize: 10.0)
        
        
        self.programa_actual_nombre.text  = "Tierra Adentro"
        self.programa_actual_nombre.textColor = .white
        self.programa_actual_nombre.textAlignment = .center
        self.programa_actual_nombre.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        if #available(iOS 9.0, *)
        {
            //Stack View
            let stackView_programa_actual   = UIStackView()
            stackView_programa_actual.axis  = NSLayoutConstraint.Axis.horizontal
            stackView_programa_actual.distribution  = UIStackView.Distribution.equalSpacing
            stackView_programa_actual.alignment = UIStackView.Alignment.center
            stackView_programa_actual.addArrangedSubview(programa_actual)
            stackView_programa_actual.addArrangedSubview(programa_actual_nombre)
            stackView_programa_actual.translatesAutoresizingMaskIntoConstraints = false
            programacion_titulos_actual.addSubview(stackView_programa_actual )
        } else {
            // Fallback on earlier versions
            print("No soporta stackView_programa_actual ")
        }
        
        
        let programacion_titulos_proximo = UIView(frame: CGRect(x:  caja_cuadrada_componente_imagen_canal.frame.maxX + 10,  y: programacion_titulos_actual.frame.minY + 20, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        
        let programa_proximo = UILabel()
        programa_proximo.text  = "PRÓXIMO: "
        programa_proximo.textColor = .gray
        programa_proximo.textAlignment = .center
        programa_proximo.font = UIFont.boldSystemFont(ofSize: 10.0)
        
        self.programa_proximo_nombre = UILabel()
        self.programa_proximo_nombre.text  = "Viva el lunes"
        self.programa_proximo_nombre.textColor = .gray
        self.programa_proximo_nombre.textAlignment = .center
        self.programa_proximo_nombre.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        if #available(iOS 9.0, *)
        {
            //Stack View
            let stackView_programa_proximo   = UIStackView()
            stackView_programa_proximo.axis  = NSLayoutConstraint.Axis.horizontal
            stackView_programa_proximo.distribution  = UIStackView.Distribution.equalSpacing
            stackView_programa_proximo.alignment = UIStackView.Alignment.center
            
            stackView_programa_proximo.addArrangedSubview(programa_proximo)
            stackView_programa_proximo.addArrangedSubview(programa_proximo_nombre)
            stackView_programa_proximo.translatesAutoresizingMaskIntoConstraints = false
            
            
            programacion_titulos_proximo.addSubview(stackView_programa_proximo )
        } else {
            // Fallback on earlier versions
            print("No soporta stackView_programa_proximo ")
        }
        
        
        
        
        programa_horario_inicio = UILabel(frame: CGRect(x: caja_cuadrada_componente_imagen_canal.frame.maxX  + 10,  y: 15, width:  50, height:  20))
        programa_horario_inicio.text  = "15:00"
        programa_horario_inicio.textColor = .gray
        programa_horario_inicio.textAlignment = .left
        programa_horario_inicio.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        let programa_horario_progressBar = UIView(frame: CGRect(x: self.programa_horario_inicio.frame.maxX + 20,  y: 25, width:  1, height: 1))
        self.progressBar = UIProgressView(progressViewStyle: .bar)
        
        // self.progressBar.frame = CGRect(x:0, y:0 ,width: 20 , height: 1); //width : es longitud total de la barra
        self.progressBar.transform = CGAffineTransform(scaleX: 1.3, y: 5.0) //scaleX : es longitud total de la barra , y: es el ancho total de la barra
        self.progressBar.setProgress(0.3, animated: true)
        self.progressBar.backgroundColor = UIColor.gray
        progressBar.layer.cornerRadius = 8
        progressBar.clipsToBounds = true
        
        let gradientLayer2 = CAGradientLayer()
        gradientLayer2.cornerRadius = 8 // change this number to get the corners you want
        gradientLayer2.masksToBounds = true
        gradientLayer2.frame = CGRect(x:0, y:0 ,width:  570 , height: 80)
        gradientLayer2.colors = [UIColor.blue.cgColor, UIColor.cyan.cgColor]
        gradientLayer2.startPoint = CGPoint(x: 0.0, y: 0.5)
        gradientLayer2.endPoint = CGPoint(x: 1.0, y: 0.5)
        UIGraphicsBeginImageContext(gradientLayer.bounds.size)
        gradientLayer2.render(in: UIGraphicsGetCurrentContext()!)
        let image = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        
        self.progressBar.progressImage = image
        
        
        programa_horario_progressBar.addSubview(self.progressBar)
        
        
        
        
        programa_horario_fin = UILabel( frame: CGRect(x:  programa_horario_progressBar.frame.maxX + 180, y: 15, width: 50, height: 20))
        programa_horario_fin.text  = "17:00"
        programa_horario_fin.textColor = .gray
        programa_horario_fin.textAlignment = .right
        programa_horario_fin.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        let btnCloseInfoEPG = UIButton( frame: CGRect(x:  480 ,  y: 20, width: 100, height: 30))
       // let btnCloseInfoEPG = UIButton( frame: CGRect(x:  520 ,  y: 20, width: 30, height: 30))
        btnCloseInfoEPG.addTarget(self, action: #selector(btnCloseEPGClicked), for: .touchUpInside)
        //btnCloseInfoEPG.setImage(UIImage(named: "ic_close"), for: .normal)
        btnCloseInfoEPG.setTitle("ic_close", for: .normal)
        btnCloseInfoEPG.imageView?.contentMode = .scaleAspectFill
        
        viewBottomEPG = UIView(frame: CGRect(x: 0 ,  y: 230, width: self.view.frame.width   , height:  (self.view.frame.maxY/1)))
        viewBottomEPG.backgroundColor = UIColor(red: 0.0, green: 0.0, blue:0.0, alpha:  0.7)
        
        
        self.titulo_canal = UILabel( frame: CGRect(x: 80, y: -15, width:  120  , height: 60))
        titulo_canal.text  = canal.titulo
        titulo_canal.textColor = .white
        titulo_canal.numberOfLines = 3
        titulo_canal.lineBreakMode = .byWordWrapping
        titulo_canal.textAlignment = .left
        titulo_canal.font = UIFont.boldSystemFont(ofSize: 12.0)
        
        viewBottomEPG.addSubview(descripcion_canal)
        
        self.descripcion_canal = UILabel( frame: CGRect(x: 80, y: 15, width:  (viewBottomEPG.frame.width / 1.4)   , height: (self.view.frame.maxY/4)))
        descripcion_canal.text  = canal.descripcion
        descripcion_canal.textColor = .white
        descripcion_canal.numberOfLines = 3
        descripcion_canal.lineBreakMode = .byWordWrapping
        descripcion_canal.textAlignment = .left
        descripcion_canal.font = UIFont.boldSystemFont(ofSize: 12.0)
        
        viewBottomEPG.addSubview(titulo_canal)
        viewBottomEPG.addSubview(descripcion_canal)
        
        
        
        viewTopEPG.isHidden = true
        viewTopEPG.layer.insertSublayer(gradientLayer, at:0)
        viewTopEPG.addSubview(caja_cuadrada_componente_numero_canal )
        viewTopEPG.addSubview(caja_cuadrada_componente_imagen_canal )
        viewTopEPG.addSubview(programacion_titulos_actual )
        viewTopEPG.addSubview(programacion_titulos_proximo )
        viewTopEPG.addSubview(programa_horario_inicio )
        viewTopEPG.addSubview(programa_horario_progressBar )
        viewTopEPG.addSubview(programa_horario_fin )
        viewTopEPG.addSubview(btnCloseInfoEPG )
        
        viewBottomEPG.isHidden = true
        
        self.view.addSubview(viewTopEPG)
        self.view.addSubview(viewBottomEPG)
        
        
        
        btnClose.frame = CGRect(x: (self.view.frame.maxX/10), y: (self.view.frame.maxY/14), width: 70, height: 40)
       // btnClose.frame = CGRect(x: (self.view.frame.maxX/10), y: (self.view.frame.maxY/14), width: 40, height: 40)
        btnClose.addTarget(self, action: #selector(closePlayer), for: .touchUpInside)
      //  btnClose.setImage(UIImage(named: "ic_close"), for: .normal)
        btnClose.setTitle("ic_close", for: .normal)
        
        
        //MARK: button airplay
        // let frame = CGRect(x: self.view.frame.maxX/1.2, y: self.view.frame.maxY/10, width: 100, height: 50)
        //  routePickerView = AVRoutePickerView(frame: frame)
        // routePickerView.backgroundColor = UIColor.clear
        // let label = UILabel(frame: routePickerView.bounds)
        // label.textColor = .white
        // routePickerView.addSubview(label)
        // label.text = "Airplay"
        
        
        btnPreview.frame = CGRect(x: (self.view.frame.maxX/3.5), y: (self.view.frame.maxY/2.0), width: 100, height: 40)
       // btnPreview.frame = CGRect(x: (self.view.frame.maxX/3.5), y: (self.view.frame.maxY/2.0), width: 40, height: 40)
        btnPreview.addTarget(self, action: #selector(btnPreviewVideoClicked), for: .touchUpInside)
       // btnPreview.setImage(UIImage(named: "ic_previous"), for: .normal)
        btnPreview.setTitle("ic_previous", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        
        btnInfoEPG.frame = CGRect(x: (self.view.frame.maxX/2.1), y: (self.view.frame.maxY/2.0), width: 70, height: 40)
       // btnInfoEPG.frame = CGRect(x: (self.view.frame.maxX/2.1), y: (self.view.frame.maxY/2.0), width: 40, height: 40)
        btnInfoEPG.addTarget(self, action: #selector(btnInfoEPGClicked), for: .touchUpInside)
        //btnInfoEPG.setImage(UIImage(named: "ic_info"), for: .normal)
        btnInfoEPG.setTitle("ic_info", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        
        btnNext.frame = CGRect(x: (self.view.frame.maxX/1.5),  y: (self.view.frame.maxY/2.0), width: 70, height: 40)
       // btnNext.frame = CGRect(x: (self.view.frame.maxX/1.5),  y: (self.view.frame.maxY/2.0), width: 40, height: 40)
        btnNext.addTarget(self, action: #selector(btnNextVideoClicked), for: .touchUpInside)
       // btnNext.setImage(UIImage(named: "ic_next"), for: .normal)
        btnNext.setTitle("ic_next", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        let gesture = UITapGestureRecognizer(target: self, action:  #selector(self.checkAction))
        
        self.view.addGestureRecognizer(gesture)
        self.view.addSubview(btnNext)
        self.view.addSubview(btnPreview)
        self.view.addSubview(btnInfoEPG)
        self.view.addSubview(btnClose)
        
        //self.view.addSubview(routePickerView)
        
    }
    
    // MARK: metodos de botones del reproductor
    @objc func checkAction(sender : UITapGestureRecognizer) {
        print("touch view gesture")
        if(viewBottomEPG.isHidden){
            self.btnClose.isHidden = false
            self.btnNext.isHidden = false
            self.btnInfoEPG.isHidden = false
            self.btnPreview.isHidden = false
            // self.routePickerView.isHidden = false
            self.showControls()
        }
        
    }
    
    @objc  func btnCloseEPGClicked(_ sender: UIButton) {
        print("btnCloseEPGClicked")
        self.viewTopEPG.isHidden = true
        self.viewBottomEPG.isHidden = true
        self.btnClose.isHidden = false
        self.btnInfoEPG.isHidden = false
    }
    
    @objc  func btnInfoEPGClicked(_ sender: UIButton) {
        print("btnInfoEPGClicked")
        self.viewTopEPG.isHidden = false
        self.viewBottomEPG.isHidden = false
        self.btnClose.isHidden = true
        self.btnInfoEPG.isHidden = true
        self.mostrarInfoEPG()
         
        
    }
    func mostrarInfoEPG(){
        
        let canal:VideoModel = listCanales[self.playVideoIndex]
        print(canal.titulo)
        
        self.txtNumeroCanal.text = String(canal.numeroCanal)
        self.titulo_canal.text = String(canal.titulo)
        self.descripcion_canal.text = String(canal.descripcion)
        
        let url_imagen_canal = URL(string: canal.imagenPath)
        if let data = try? Data(contentsOf: url_imagen_canal!)
        {
            let image: UIImage = UIImage(data: data)!
            self.imagen_canal.image = image;
        }else{
            print("error SSL imagen ")
        }
         
        let myString = String(currentCanal!.studio)
         
        programa_horario_inicio.text = "00:00"
        progressBar.setProgress(0, animated: true)
        programa_horario_fin.text = "00:00"
        programa_actual_nombre.text = "NO_TITLE"
        programa_proximo_nombre.text = "NO_TITLE"
        
        let url = URL(string: self.urlEPG.replacingOccurrences(of: "STUDIO", with: myString))!
        print(url)
        let task = URLSession.shared.dataTask(with: url) {(data, response, error) in
            guard let data = data else { return }
            
            if let programacion_json = try? JSONSerialization.jsonObject(with: data, options: [])  as? [String: Any]
            {
                if let error = programacion_json["error"] {
                    print("Result error: statusCode: \(error) , mensaje: token invalido")
                }else{
                    
                
                guard let programaciones = programacion_json["epg"] as? [[String:Any]] else { return }
                
                
                for programacion in programaciones{
                    
                    let run =   (programacion["run"]  as AnyObject? as? Int) ?? 0
                    let desc = programacion["desc"] as? String ?? ""
                    let siguiente = programacion["siguiente"] as? String ?? ""
                    let titulo = programacion["titulo"] as? String ?? ""
                    let fechaIni = programacion["fecha_ini"] as? Double ??  0.0
                    let fechaFin = programacion["fecha_fin"] as? Double ??  0.0
                    
                    let epg: Epg! = Epg(run: run, desc: desc, siguiente: siguiente, titulo: titulo, fechaFin: fechaFin, fechaIni: fechaIni)
                    self.list.append(epg)
                }
                
                var programa_actual:Epg?
                for item in self.list{
                    let now = Date()
                    let fechaIni  = Date(timeIntervalSince1970: item.fechaIni)
                    let fechaFin  = Date(timeIntervalSince1970: item.fechaFin)
                    
                    if(fechaIni <= now && fechaFin>=now){
                       programa_actual = item
                    }
                }
                
                if(true){
                    
                    DispatchQueue.main.async {
                         
                        
                        let siguiente_index  =  self.list.firstIndex { (item) -> Bool in
                            return item.titulo.contains(programa_actual!.siguiente)
                        }
                         
                        let programa_siguiente:Epg = self.list[siguiente_index!]
                        let percentage2 = self.getProgress(programa_actual: programa_actual!)
                        
                        self.progressBar.setProgress(percentage2, animated: true)
                         
                        
                        let strDate_hora_inicio = self.getDateFromTimeStamp(timeStamp: programa_actual!.fechaIni)
                        
                        let strDate_hora_fin = self.getDateFromTimeStamp(timeStamp: programa_actual!.fechaFin)
                        
                        
                        self.programa_actual_nombre.text = programa_actual?.titulo
                        self.programa_proximo_nombre.text = programa_siguiente.titulo
                        self.programa_horario_inicio.text = strDate_hora_inicio
                        self.programa_horario_fin.text = strDate_hora_fin
                    }
                }
              }
            
            }
            
        }
        
        task.resume()
    }
    func getDateFromTimeStamp(timeStamp : Double) -> String {
        
        let date = NSDate(timeIntervalSince1970: timeStamp)
        
        let dayTimePeriodFormatter = DateFormatter()
         // dayTimePeriodFormatter.dateFormat = "dd MMM YY, hh:mm a"
        // UnComment below to get only time
        dayTimePeriodFormatter.dateFormat = "hh:mm"
        
        let dateString = dayTimePeriodFormatter.string(from: date as Date)
        return dateString
    }
     
    func getProgress(programa_actual:Epg) -> Float{
        
        let startDate =   Date(timeIntervalSince1970: programa_actual.fechaIni)
        let endDate =  Date(timeIntervalSince1970: programa_actual.fechaFin)
        let now = Date()
        
        let dayTimePeriodFormatter = DateFormatter()
        dayTimePeriodFormatter.dateFormat = "HH:mm:ss"
        let startDateString = dayTimePeriodFormatter.string(from: startDate)
        let endDateString = dayTimePeriodFormatter.string(from: endDate)
        let nowDateString = dayTimePeriodFormatter.string(from: now)
        
        let formatter2 = DateFormatter()
        formatter2.dateFormat = "yyyy-MM-dd"
        let someDateTime = formatter2.string(from: now)
        
        
        let string_startDateString = someDateTime+" "+startDateString
        let string_endDateString = someDateTime+" "+endDateString
        let string_nowDateString = someDateTime+" "+nowDateString
        
        let formatter = DateFormatter()
        formatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        
        
        let startDate2 = formatter.date(from: string_startDateString)!
        let duration2 = formatter.date(from: string_endDateString)!.timeIntervalSince(startDate2)
        let elapsed2 = formatter.date(from: string_nowDateString)!.timeIntervalSince(startDate2)
        
        let percentage2:Float = Float( elapsed2 / duration2 )
        return percentage2
    }
    
    @objc func btnNextVideoClicked(sender: UIButton!) {
        self.playVideoIndex+=1
        
        if(self.playVideoIndex >= listCanales.count){
           self.playVideoIndex = 0
            
            player?.removeAllItems()
            
              currentCanal =  listCanales[playVideoIndex]
            let url = URL(string: currentCanal!.linkReproductor)
            let newItem = AVPlayerItem(url: url!)
            self.player?.replaceCurrentItem(with: newItem)
            
        }else{
            player?.removeAllItems()
            
            currentCanal = listCanales[playVideoIndex]
            let url = URL(string: currentCanal!.linkReproductor)
            let newItem = AVPlayerItem(url: url!)
            self.player?.replaceCurrentItem(with: newItem)
            
        }
        self.showControls()
        self.mostrarInfoEPG()
    }
    
    @objc func btnPreviewVideoClicked(_ sender: UIButton) {
        
        if(self.playVideoIndex  == 0){
            self.playVideoIndex = listCanales.count
        }
        self.playVideoIndex =  self.playVideoIndex - 1
        player?.removeAllItems()
        currentCanal = listCanales[playVideoIndex]
        let url = URL(string:   currentCanal!.linkReproductor)
        let newItem = AVPlayerItem(url: url!)
        self.player?.replaceCurrentItem(with: newItem)
        
        self.showControls()
        self.mostrarInfoEPG()
        
    }
    @objc func closePlayer(_ sender: UIButton) {
        print("closePlayer")
        self.dismiss(animated: true, completion: nil)
        let value = UIInterfaceOrientation.portrait.rawValue
        UIDevice.current.setValue(value, forKey: "orientation")
        
    }
    
    private func showControls(){
        
        delayWithSeconds(7) {
            
            self.btnClose.isHidden = true
            self.btnInfoEPG.isHidden = true
            // self.routePickerView.isHidden = true
            
        }
    }
    public func getCurrentLink() -> String{
        
        let url: URL? = (player?.currentItem?.asset as? AVURLAsset)?.url
        
        return url!.absoluteString
    }
    
   // MARK: establecer cambio de pantalla a landscape left o right
    override var supportedInterfaceOrientations: UIInterfaceOrientationMask {
        let orientation: UIInterfaceOrientationMask = [UIInterfaceOrientationMask.landscape]
        //, UIInterfaceOrientationMask.landscapeRight
                     return orientation
    }
    
    // MARK: Utilidades
    private func getTimeString(from time: CMTime) -> String {
        let totalSeconds = CMTimeGetSeconds(time)
        let hours = Int(totalSeconds/3600)
        let minutes = Int(totalSeconds/60) % 60
        let seconds = Int(totalSeconds.truncatingRemainder(dividingBy: 60))
        if hours > 0 {
            return String(format: "%i:%02i:%02i", arguments: [hours,minutes,seconds])
        }else {
            return String(format: "%02i:%02i", arguments: [minutes,seconds])
        }
    }
    private func delayWithSeconds(_ seconds: Double, completion: @escaping () -> ()) {
        DispatchQueue.main.asyncAfter(deadline: .now() + seconds) {
            completion()
        }
    }
    private func showActivityIndicatory() {
        let container: UIView = UIView()
        container.frame = CGRect(x: 0, y: 0, width: 80, height: 80) // Set X and Y whatever you want
        container.backgroundColor = .clear
        
        self.activityView = UIActivityIndicatorView(style: .whiteLarge)
        self.activityView?.center = self.view.center
        
        container.addSubview(self.activityView!)
        self.view.addSubview(container)
        self.activityView!.startAnimating()
    }
}
